<?php
/*
Plugin Name: My favorite posts
Plugin URI: http://www.kriesi.at/
Description: Registered users can mark posts as favorite posts and display a list of these posts
Version: 1.2
Author: Christian "Kriesi" Budschedl
Author URI: http://kriesi.at/
*/


/*  Copyright 2008  Christian Budschedl  (email : office@kriesi.at)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
global $table_name, $plugin_version;

$table_name = $wpdb->prefix . 'fav_me';
$plugin_version = "1.2";


register_activation_hook( __FILE__, 'mfp_install'); // starts the installation of the database if the plugin is activated
add_action('init', 'mfp_modify_database'); // calls function mfp_modify_database() at the initialisation of each page


# ----------------------------------
function mfp_install() {
# ----------------------------------
global $wpdb, $version, $table_name;

if (!(current_user_can('level_8'))){ // if the user is no admin stop the function here
  return;
};

$table_name = $wpdb->prefix . 'fav_me';

if ($wpdb->get_var("show tables like '$table_name'") != $table_name) { // creates Databse only if a database with this name doesnt exist
  # Create DB table
  $sql = "CREATE TABLE $table_name ("
       ." id int(11) UNSIGNED NOT NULL AUTO_INCREMENT,"
	   ." user_id MEDIUMINT NOT NULL,"
	   ." post_id TEXT NOT NULL,"
	   ." UNIQUE KEY id (id)"
	   ." ) TYPE = MYISAM;";
  require_once(ABSPATH.'wp-admin/upgrade-functions.php');
  dbDelta($sql);
}
# ----------------------------------
} # end mfp_install
# ----------------------------------


# ----------------------------------
function mfp_the_link($var="") { // function to display the "add post to favs" link in front end
# ----------------------------------
if (current_user_can('level_0')){ // if the user is logged in
global $user_ID, $post, $wpdb, $table_name; // get current user id and current post id

//variables we are looking for
$defaults = array(
		'add_link' => 'Add this post to your favorite post list', 
		'remove_link' => 'Remove this post from your favorite post list'
	);

	$endvar = wp_parse_args( $var, $defaults );	
	extract( $endvar, EXTR_SKIP );
	$post_ID = $post->ID; 
	$mod_url = mfp_create_link_url();
	
	$data = $wpdb->get_var("SELECT post_id FROM $table_name WHERE user_id = '$user_ID'");
		if (!(preg_match("/(^".$post_ID.",|,".$post_ID."$|^".$post_ID."$|,".$post_ID.",)/",$data))){
			echo "<a href='".$mod_url."favorite-post=$post_ID'>".$endvar['add_link']."</a>"; // creates a link for adding the post to the database
		} else{
			echo "<a href='".$mod_url."remove-post=$post_ID'>".$endvar['remove_link']."</a>"; // creates a link for removing the post to the database
		}
	}
# ----------------------------------
} # end mfp_the_link
# ----------------------------------


# ----------------------------------
function mfp_create_link_url(){
# ----------------------------------

	$current_url = $_SERVER['REQUEST_URI'];
	if(preg_match("/(\?|&)?(remove-post=|favorite-post=)[0-9]+$/",$current_url)){
		$current_url = preg_replace("/(\?|&)?(remove-post=|favorite-post=)[0-9]+/","",$current_url);
	} else{
		$current_url = preg_replace("/(remove-post=|favorite-post=)[0-9]+&?/","",$current_url);
	}
	preg_match("/\?/", $current_url) == 0 ? $mod_url= $current_url."?" :  $mod_url= $current_url."&"; // checks if there is a ? in the URL
	return $mod_url;
	
# ----------------------------------
} # end mfp_the_link
# ----------------------------------


# ----------------------------------
function mfp_modify_database(){
# ----------------------------------
if (current_user_can('level_0') && (isset($_GET['favorite-post']) || isset($_GET['remove-post']))){

		global $user_ID, $wpdb, $table_name;
		
		$post_ID = $wpdb->escape($_GET['favorite-post']);
		$remove_post_ID = $wpdb->escape($_GET['remove-post']);
		
	if(preg_match("/^[0-9]+$/",$post_ID) || preg_match("/^[0-9]+$/",$remove_post_ID)){
		$data = $wpdb->get_var("SELECT post_id FROM $table_name WHERE user_id = '$user_ID'");
		if ($post_ID != ""){ // if the user wants to add a post
			if ($data == ""){
				$wpdb->query("INSERT INTO $table_name (user_id, post_id) VALUES ('$user_ID','$post_ID')"); 
			}else{
				if (!(preg_match("/(^".$post_ID.",|,".$post_ID."$|^".$post_ID."$|,".$post_ID.",)/",$data))){
					$data .= ",".$post_ID;
					$wpdb->query("UPDATE $table_name SET post_id ='$data' WHERE user_id='$user_ID'");
				}
			}
		}
	
		if ($remove_post_ID != "" && $data != ""){ // if the user wants to remove a post
			if ($data == $remove_post_ID){
				$wpdb->query("DELETE FROM $table_name WHERE user_id = '$user_ID'");
			} else {
				$data = preg_replace("/(^".$remove_post_ID.",|,".$remove_post_ID."$|^".$remove_post_ID."$)/","", $data);
				$data = preg_replace("/,".$remove_post_ID.",/",",", $data);
				$wpdb->query("UPDATE $table_name SET post_id ='$data' WHERE user_id='$user_ID'");
			}
		}
	}
}
# ----------------------------------
} # end mfp_modify_database
# ----------------------------------


# ----------------------------------
function mfp_display($var="",$show_user=""){
# ----------------------------------
global $wpdb, $user_ID, $table_name;

if($show_user == ""){
	$query_user = $user_ID;
}else{
	$query_user = $show_user;
}

if (current_user_can('level_0') || $show_user != ""){
$table_name2 = $wpdb->prefix . 'posts';



$sql = "";
$fav_post ="";

$defaults = array(
		'title' => '', 
		'display' => 'list',
		'remove_link' => 'remove',
		'class' => 'mfp_favorites',
		'link_class' => 'mfp_link',
		'remove_link_class' => 'mfp_remove_link',
		'order_by' => 'ID'
	);

$data = $wpdb->get_var("SELECT post_id FROM $table_name WHERE user_id = '$query_user'");

if ($data == ""){
	if($show_user == ""){
echo "<p>You are logged in now so start adding posts you like to your personal favorite post list. <br/> You can find the link for adding a post to this list at the end of each entry.</p>";
	}else{
echo "<p>This user has not marked any posts as favorite posts yet.</p>";	
	}
}else{

	$dataarray = explode(',',$data);
		foreach ($dataarray as $entry){
							$sql .= "OR ID = '$entry' ";
						}	
						
		$endvar = wp_parse_args( $var, $defaults );
		extract( $endvar, EXTR_SKIP );
						
		$sql = preg_replace("/^OR./","", $sql);	
		$order = $endvar['order_by'];
		$my_posts = $wpdb->get_results("SELECT * FROM $table_name2 WHERE $sql ORDER BY $order");
		$mod_url = mfp_create_link_url();
		
		
		
		if ($endvar['display'] == "list"){
		$wrap_before = "<ul class='".$endvar['class']."'>";
		$wrap_after = "</ul>";
		$entry_before = "<li>";
		$entry_after = "</li>";
		} else if ($endvar['display'] == "div"){
		$wrap_before = "<div class='".$endvar['class']."'>";
		$wrap_after = "</div>";
		$entry_before = "<p>";
		$entry_after = "</p>";
		}
		
		foreach ($my_posts as $entry){
			$fav_post .= $entry_before."<a href='".get_permalink($entry->ID)."' title='".$entry->post_title."' class='".$endvar['link_class']."'>".$entry->post_title."</a>";
			if($show_user == "" || $show_user == $user_ID){
			$fav_post .= "<a href='".$mod_url."remove-post=".$entry->ID."' class='".$endvar['remove_link_class']."'>".$endvar['remove_link']."</a>".$entry_after;
			}
		}
		
		
		//ausgabe
		echo $title;
		echo $wrap_before;
		echo $fav_post;
		echo $wrap_after;
	}
}
# ----------------------------------
} # end mfp_display
# ----------------------------------


# ----------------------------------
#WIDGET SETTINGS
# ----------------------------------
function widget_mfp_init(){
	if ( !function_exists('register_sidebar_widget') ) {
		return;
	}
	
	function mfp_display_widget($args) {
			if(current_user_can("level_0")){
			
			
          extract($args);
		  $options  = get_option('mfp_display_widget');
		  
		  $title = empty( $options['mfp_title'] ) ? '' : $options['mfp_title'];
		  $display = empty( $options['mfp_display'] ) ? '' : "display=".$options['mfp_display'];
		  $remove_link = empty( $options['mfp_remove_link'] ) ? '' : "&remove_link=".$options['mfp_remove_link'];
		  $class = empty( $options['mfp_class'] ) ? '' : "&class=".$options['mfp_class'];
		  $link_class = empty( $options['mfp_link_class'] ) ? '' : "&link_class=".$options['mfp_link_class'];
		  $remove_link_class = empty( $options['mfp_remove_link_class'] ) ? '' : "&remove_link_class=".$options['mfp_remove_link_class'];
		  $order_by = empty( $options['mfp_order_by'] ) ? '' : "&order_by=".$options['mfp_order_by'];
		  
		    echo $before_widget;
  			echo $before_title;
			echo $title;			
			echo $after_title;
			mfp_display("title=&".$display.$remove_link.$class.$link_class.$remove_link_class.$order_by);
  			echo $after_widget;
            }
	  }
	function mfp_control_display_widget(){
		$options = $newoptions = get_option('mfp_display_widget');
		
		if ( $_POST['mfp-submit'] ) {
		$newoptions['mfp_title'] = strip_tags(stripslashes($_POST['mfp_title']));
		$newoptions['mfp_display'] = strip_tags(stripslashes($_POST['mfp_display']));
		$newoptions['mfp_remove_link'] = strip_tags(stripslashes($_POST['mfp_remove_link']));
		$newoptions['mfp_class'] = strip_tags(stripslashes($_POST['mfp_class']));
		$newoptions['mfp_link_class'] = strip_tags(stripslashes($_POST['mfp_link_class']));
		$newoptions['mfp_remove_link_class'] = strip_tags(stripslashes($_POST['mfp_remove_link_class']));
		$newoptions['mfp_order_by'] = strip_tags(stripslashes($_POST['mfp_order_by']));
	

	}
		if ( $options != $newoptions ) {
		$options = $newoptions;
		update_option('mfp_display_widget', $options);
		}
		
		
		?>
        <p>This wiget displays a list of the users favorite posts, it works fine without any change of the settings.<br/>
        You can get more information on the various settings at <a href="http://www.kriesi.at/archives/wordpress-plugin-my-favorite-posts" title="plugin homepage">Kriesi.at</a>
        </p>
		<p>
<input id="mfp-submit" type="hidden" value="1" name="mfp-submit"/>

<label for="mfp_title">Title: <small> (default is no title)</small></label>
<input id="mfp_title" class="widefat" type="text" value="<?php echo $newoptions['mfp_title']; ?>" name="mfp_title"/>
</p><p>
<label for="mfp_display">Display: <small>(Default is "list" -> you may change it to "div")</small></label>
<input id="mfp_display" class="widefat" type="text" value="<?php echo $newoptions['mfp_display'] ?>" name="mfp_display"/>
</p><p>
<label for="mfp_remove_link">Text for remove link: <small>(default is "remove")</small></label>
<input id="mfp_remove_link" class="widefat" type="text" value="<?php echo $newoptions['mfp_remove_link']; ?>" name="mfp_remove_link"/>
</p><p>
<label for="mfp_class">Class for ul/div: <small>(defaul is "mfp_favorites")</small></label>
<input id="mfp_class" class="widefat" type="text" value="<?php echo $newoptions['mfp_class']; ?>" name="mfp_class"/>
</p><p>
<label for="mfp_link_class">Class for the post link  <small>(default is "mfp_link")</small></label>
<input id="mfp_link_class" class="widefat" type="text" value="<?php echo $newoptions['mfp_link_class']; ?>" name="mfp_link_class"/>
</p><p>
<label for="mfp_remove_link_class">Class for remove link: <small>(default is "mfp_remove_link")</small></label>
<input id="mfp_remove_link_class" class="widefat" type="text" value="<?php echo $newoptions['mfp_remove_link_class']; ?>" name="mfp_remove_link_class"/>
</p><p>
<label for="mfp_order_by">Order of items: <small>(default is ID, you can change that to any field name of the wp_posts table: some examples would be "post_title", "post_author", "post_date")</small></label>
<input id="mfp_order_by" class="widefat" type="text" value="<?php echo $newoptions['mfp_order_by']; ?>" name="mfp_order_by"/>
</p>
        <p><br /><small>Attention: if you want to use html tags you must directly include the mfp_display() function in your tempalte file</small></p>

		
<?php }	  
	
	   register_sidebar_widget('My Favorite Posts', 'mfp_display_widget');
	   register_widget_control('My Favorite Posts', 'mfp_control_display_widget');

}


	  
	  add_action('widgets_init', 'widget_mfp_init');
      //  register_sidebar_widget('My Favorite Posts', 'mfp_display_widget');
	  // register_widget_control('My Favorite Posts', 'mfp_control_display_widget');




?>